import { FC } from "react";
import { Colors } from "@cs-bosch-medusa/ui";
export type ChartTileProps = {
    /**
     * Identifier of the tile.
     * The `ChartTileContainer` uses this identifier
     * in order to determine the activated state of the tile.
     */
    id: string;
    /** Value to display the chart current value. */
    value: number | string;
    /** Unit to display after the value. */
    unit: string;
    /** Label to display at the bottom of the tile. */
    label: string;
    /** Color to apply as text and top line color. */
    color: Colors;
};
/**
 * NOTE: Hide internal values from the public.
 */
export type InternalChartTileProps = ChartTileProps & {
    /**
     * If true, then the tile will be shown with the given color,
     * otherwise the theme's tileDeactivatedColor will be applied.
     *
     * Defaults to `true`
     * */
    activated?: boolean;
};
export declare const ChartTile: FC<ChartTileProps>;
//# sourceMappingURL=chart-tile.d.ts.map