"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Bars = void 0;
const react_1 = __importStar(require("react"));
const d3Shape = __importStar(require("d3-shape"));
const react_native_svg_1 = require("react-native-svg");
const theme_1 = require("../../theme");
const Bars = ({ values, colors, xScale, yScale, barWidth, activeParameters, selectedTimestamp, }) => {
    const { chartTheme } = (0, theme_1.useChartTheme)();
    const stackGenerator = (0, react_1.useMemo)(() => d3Shape
        .stack()
        .order(d3Shape.stackOrderReverse)
        .keys(activeParameters)
        .offset(d3Shape.stackOffsetDiverging)
        .value((d, key) => { var _a; return (_a = d[key]) !== null && _a !== void 0 ? _a : 0; }), [activeParameters]);
    const stacks = (0, react_1.useMemo)(() => stackGenerator(Object.values(values)), [stackGenerator, values]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        selectedTimestamp && (react_1.default.createElement(react_native_svg_1.Line, { stroke: chartTheme.doubleAxisChart.labelColor, strokeWidth: 1, x: xScale(selectedTimestamp), y1: 0, y2: yScale.range()[0] })),
        stacks.map((data) => (react_1.default.createElement(react_native_svg_1.G, { key: `bar${data.key}${data.index}` }, data.map((value) => {
            const [y1, y2] = value;
            return (react_1.default.createElement(react_native_svg_1.Rect, { fill: colors[data.key], height: yScale(y1) - yScale(y2), key: `rect${data.key}${value.data.timestamp}`, stroke: chartTheme.doubleAxisChart.backgroundColor, strokeWidth: chartTheme.doubleAxisChart.lineWidth, width: barWidth, x: xScale(value.data.timestamp) - barWidth / 2, y: yScale(y2) }));
        }))))));
};
exports.Bars = Bars;
