import { FC } from "react";
import * as d3Scale from "d3-scale";
type DoubleAxisXLabelsProps = {
    /** Timestamp values to display on the x axis. */
    axisTickTimestamps: number[];
    /** Timestamps for the smaller ticks. */
    secondaryXTickTimestamps?: number[];
    /** Height of the chart. */
    height: number;
    /** Scale of the x values. */
    xScale: d3Scale.ScaleTime<number, number>;
    /**
     * Function that formats the timestamps to be displayed on the X axis.
     *
     * @param date  the timestamp to format
     */
    formatDate(date: Date): string;
    /** Whether there is a timestamp selected on the chart. */
    selection: boolean;
};
export declare const DoubleAxisXLabels: FC<DoubleAxisXLabelsProps>;
export {};
//# sourceMappingURL=double-axis-x-labels.d.ts.map