import { FC } from "react";
import * as d3Scale from "d3-scale";
type DoubleAxisYLabelsProps = {
    /** Width of the chart. */
    width: number;
    /** Values to display on the y axis. */
    axisTickValues: number[];
    /** Scale of the y values. */
    scale: d3Scale.ScaleLinear<number, number>;
    /**
     * Whether to display the labels on the secondary axis
     * instead of the main axis. When `true` the text will
     * appear along the secondary axis on the right side of the chart.
     */
    secondary?: boolean;
    /**
     * Function that formats the values to be displayed on the Y axis.
     *
     * @param value  the value to format
     * @param secondary  whether the label belongs to the secondary axis
     */
    formatValue(value: number, secondary: boolean): string;
    /** Whether there is a timestamp selected on the chart. */
    selection: boolean;
};
export declare const DoubleAxisYLabels: FC<DoubleAxisYLabelsProps>;
export {};
//# sourceMappingURL=double-axis-y-labels.d.ts.map