"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HorizontalTimeLineSvg = void 0;
const ui_1 = require("@cs-bosch-medusa/ui");
const react_1 = __importStar(require("react"));
const react_native_svg_1 = __importDefault(require("react-native-svg"));
const d3Scale = __importStar(require("d3-scale"));
const horizontal_time_line_metrics_1 = require("./horizontal-time-line-metrics");
const horizontal_time_line_indicator_1 = require("./horizontal-time-line-indicator");
const horizontal_time_line_axis_1 = require("./horizontal-time-line-axis");
/**
 * Horizontal timeline SVG.
 */
const HorizontalTimeLineSvg = ({ height, width, timestampRange, currentTimestamp, tickCount, smallTickCount, labelFrequency, indicatorColor, formatLabel, testID, }) => {
    const [xMin, xMax] = timestampRange;
    const scale = (0, react_1.useMemo)(() => d3Scale
        .scaleTime()
        .domain([xMin, xMax])
        .range([
        horizontal_time_line_metrics_1.HORIZONTAL_TIME_LINE_METRICS.CONTAINER_PADDING,
        width - horizontal_time_line_metrics_1.HORIZONTAL_TIME_LINE_METRICS.CONTAINER_PADDING,
    ]), [xMin, xMax, width]);
    return (react_1.default.createElement(react_native_svg_1.default, { height: height, width: width, ...(0, ui_1.getTestIdProps)(testID) },
        currentTimestamp !== undefined && (react_1.default.createElement(horizontal_time_line_indicator_1.HorizontalTimeLineIndicator, { color: indicatorColor, height: height, position: currentTimestamp, scale: scale })),
        react_1.default.createElement(horizontal_time_line_axis_1.HorizontalTimeLineAxis, { formatLabel: formatLabel, height: height, labelFrequency: labelFrequency, scale: scale, smallTickCount: smallTickCount, tickCount: tickCount, timestampRange: timestampRange, width: width })));
};
exports.HorizontalTimeLineSvg = HorizontalTimeLineSvg;
