"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParamListItem = void 0;
const react_1 = __importStar(require("react"));
const ui_1 = require("@cs-bosch-medusa/ui");
const react_native_1 = require("react-native");
const color_indicator_1 = require("./color-indicator");
const styles = react_native_1.StyleSheet.create({
    checkbox: {
        paddingLeft: 0,
        paddingRight: ui_1.METRICS.ICON.basePadding,
        paddingVertical: 0,
    },
});
const ParamListItem = ({ item, colors, selected, disableUnselected, testID, onPress, }) => {
    const itemColor = selected ? colors[item.id] : undefined;
    const itemDisabled = !selected && disableUnselected;
    const onItemPress = (0, react_1.useCallback)(() => {
        onPress(item.id);
    }, [item.id, onPress]);
    return (react_1.default.createElement(ui_1.ListItem, { disabled: itemDisabled, leftComponent: react_1.default.createElement(color_indicator_1.ColorIndicator, { color: itemColor }), onPress: onItemPress, rightComponent: react_1.default.createElement(ui_1.ColoredCheckbox, { color: itemColor !== null && itemColor !== void 0 ? itemColor : ui_1.Colors.TRANSPARENT, disabled: itemDisabled, onValueChange: onItemPress, style: styles.checkbox, testID: `${testID}.checkBox`, value: selected }), testID: testID, text: item.label }));
};
exports.ParamListItem = ParamListItem;
