import { FC } from "react";
import { Colors, TestProps } from "@cs-bosch-medusa/ui";
import { ParameterItem } from "./types";
export type ParameterListProps = TestProps & {
    /** The ids of the parameters that are selected. */
    activeParameters: string[];
    /** Parameters to display in the list. */
    items: ParameterItem[];
    /** Parameter ids mapped to colors. */
    colors: Record<string, Colors>;
    /** Disable all checkboxes that aren't selected. */
    disableUnselected?: boolean;
    /**
     * Callback that is called with the updated list
     * when a selection changes.
     */
    onChange(activatedParameters: string[]): void;
    /**
     * If `true`, list items will span the entire width of the screen.
     * Default is `true`.
     */
    fullWidth?: boolean;
};
export declare const ParameterList: FC<ParameterListProps>;
//# sourceMappingURL=parameter-list.d.ts.map