"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RealTimeLineChartYAxisLabels = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const ui_1 = require("@cs-bosch-medusa/ui");
const real_time_line_chart_metrics_1 = require("./real-time-line-chart-metrics");
const theme_1 = require("../../theme");
const TEXT_VERTICAL_SHIFT = (0, ui_1.verticalScale)(4);
const RealTimeLineChartYAxisLabels = ({ axisTickValues, scale, formatValue }) => {
    const { theme } = (0, ui_1.useTheme)();
    const { chartTheme } = (0, theme_1.useChartTheme)();
    return (
    // eslint-disable-next-line react/jsx-no-useless-fragment
    react_1.default.createElement(react_1.default.Fragment, null, axisTickValues.map((value) => (react_1.default.createElement(react_native_svg_1.G, { key: value },
        react_1.default.createElement(react_native_svg_1.Text, { fill: chartTheme.realTimeLineChart.axisColor, fontFamily: theme.regularFont, fontSize: ui_1.FontSize.VERY_TINY, textAnchor: "end", x: real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.Y_TICKS_PADDING, y: scale(value) - TEXT_VERTICAL_SHIFT }, formatValue(value)))))));
};
exports.RealTimeLineChartYAxisLabels = RealTimeLineChartYAxisLabels;
