import React from "react";
import { RealTimeLineChartIntervalRange, RealTimeLineChartValues } from "./real-time-line-chart-props";
export type RealTimeLineChartRef = {
    /**
     * Returns the base64 string representation of
     * an image/png data from the svg component.
     */
    toBase64(): Promise<string>;
};
/**
 * Real-time based line chart svg component.
 */
export declare const RealTimeLineChart: React.ForwardRefExoticComponent<import("@cs-bosch-medusa/ui").TestProps & {
    width: number;
    height: number;
    xTicksNumber: number;
    yTicksNumber: number;
    activeParameters: string[];
    formatDate(date: Date): string;
    formatValue(value: number): string;
    values: RealTimeLineChartValues;
    colors: {
        [key: string]: import("@cs-bosch-medusa/ui").Colors;
    };
    initialIntervalRange: RealTimeLineChartIntervalRange;
    defaultIntervalRange?: Partial<RealTimeLineChartIntervalRange> | undefined;
    showPoints?: boolean | undefined;
    interval?: number | undefined;
    rightSideTimeShift?: number | undefined;
    withBackground?: boolean | undefined;
} & React.RefAttributes<RealTimeLineChartRef>>;
//# sourceMappingURL=real-time-line-chart.d.ts.map