import type { TextStyle, ViewStyle } from "react-native";
import type { Theme } from "react-native-calendars/src/types";
interface CalendarThemeIdStyle {
    [themeId: string]: ViewStyle | TextStyle;
}
/**
 * Patched theme for react-native-calendars. Inspired by definitions
 * found in @types/react-native-calendars.
 */
export type CalendarTheme = Theme & {
    "stylesheet.calendar.header"?: CalendarThemeIdStyle | undefined;
    "stylesheet.calendar.main"?: CalendarThemeIdStyle | undefined;
    "stylesheet.calendar-list.main"?: CalendarThemeIdStyle | undefined;
    "stylesheet.agenda.main"?: CalendarThemeIdStyle | undefined;
    "stylesheet.agenda.list"?: CalendarThemeIdStyle | undefined;
    "stylesheet.day.basic"?: CalendarThemeIdStyle | undefined;
    "stylesheet.day.single"?: CalendarThemeIdStyle | undefined;
    "stylesheet.day.multiDot"?: CalendarThemeIdStyle | undefined;
    "stylesheet.day.period"?: CalendarThemeIdStyle | undefined;
    "stylesheet.dot"?: CalendarThemeIdStyle | undefined;
};
/**
 * A Date interface for objects that can format themselves into
 * ISO strings, be it a JS Date object or the XDate used by calendars.
 */
export interface ISOCompatibleDate {
    toISOString(): string;
}
/**
 * A minimal interface compatible with DateData that only lists the subset of
 * fields our code uses.
 */
export interface DateWithTimestamp {
    timestamp: number;
}
export { MarkingProps } from "react-native-calendars/src/calendar/day/marking";
//# sourceMappingURL=patched-types.d.ts.map