import { FC } from "react";
import { Animated, StyleProp, ViewStyle } from "react-native";
import { TestProps } from "../../util";
export type AnimatedPageIndicatorProps = {
    /**
     * The horizontal scroll position that the view is currently at.
     */
    scrollX: Animated.Value;
    /**
     * The width of the component inside of which scrolling/paging
     * is happening.
     */
    parentWidth: number;
    /** The number of pages to show indicators for. */
    pageCount: number;
    /**
     * Callback to be called when a dot is pressed.
     * It receives the index of the pressed dot as argument.
     */
    onPress?: (pressedIndex: number) => void;
    /** Custom styling to pass to the component. */
    style?: StyleProp<ViewStyle>;
} & TestProps;
export declare const AnimatedPageIndicator: FC<AnimatedPageIndicatorProps>;
//# sourceMappingURL=animated-page-indicator.d.ts.map