"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Carousel = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const util_1 = require("../../util");
const animated_page_indicator_1 = require("./animated-page-indicator");
const styles = react_native_1.StyleSheet.create({
    container: {
        flex: 1,
    },
});
/**
 * A horizontally swipeable container,
 * which makes the children components to swipe it horizontally.
 */
const Carousel = ({ children, style, indicatorPressable = true, testID, }) => {
    const { theme } = (0, theme_1.useTheme)();
    const [width, setWidth] = (0, react_1.useState)(0);
    const scrollViewRef = (0, react_1.useRef)(null);
    const scrollX = (0, react_1.useRef)(new react_native_1.Animated.Value(0)).current;
    const { backgroundColor } = react_native_1.StyleSheet.flatten([
        { backgroundColor: theme.backgroundColor },
        style,
    ]);
    /**
     * NOTE: Apply the width for the children elements
     * in order to avoid content width overflowing.
     */
    const newChildren = react_1.default.Children.map(children, (element) => {
        if (!react_1.default.isValidElement(element))
            return;
        const { style, ...restProps } = element.props;
        return react_1.default.cloneElement(element, {
            ...restProps,
            style: [{ width }, style],
        });
    });
    const childrenLength = react_1.default.Children.count(children);
    const showProcessIndicatorDots = childrenLength > 1;
    const onLayout = (0, react_1.useCallback)((event) => {
        setWidth(event.nativeEvent.layout.width);
    }, []);
    const onScroll = react_native_1.Animated.event([
        {
            nativeEvent: {
                contentOffset: {
                    x: scrollX,
                },
            },
        },
    ], { useNativeDriver: false });
    const onPagePress = (0, react_1.useCallback)((pressedIndex) => {
        var _a;
        (_a = scrollViewRef.current) === null || _a === void 0 ? void 0 : _a.scrollTo({ x: pressedIndex * width });
    }, [width]);
    return (react_1.default.createElement(react_native_1.View, { onLayout: onLayout, style: [styles.container, { backgroundColor }] },
        react_1.default.createElement(react_native_1.Animated.ScrollView, { alwaysBounceHorizontal: showProcessIndicatorDots, contentContainerStyle: style, horizontal: true, onScroll: showProcessIndicatorDots ? onScroll : undefined, pagingEnabled: true, ref: scrollViewRef, scrollEventThrottle: 16, showsHorizontalScrollIndicator: false, showsVerticalScrollIndicator: false, ...(0, util_1.getTestIdProps)(testID) }, newChildren),
        showProcessIndicatorDots && (react_1.default.createElement(animated_page_indicator_1.AnimatedPageIndicator, { onPress: indicatorPressable ? onPagePress : undefined, pageCount: childrenLength, parentWidth: width, scrollX: scrollX, testID: `${testID}.indicator` }))));
};
exports.Carousel = Carousel;
