"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBorderedCheckboxStyle = exports.checkboxStyles = exports.LINE_THICKNESS = void 0;
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const icons_1 = require("../icons");
exports.LINE_THICKNESS = 10;
exports.checkboxStyles = react_native_1.StyleSheet.create({
    checkbox: {
        alignItems: "center",
        height: icons_1.IconSize.XSMALL,
        justifyContent: "center",
        width: icons_1.IconSize.XSMALL,
    },
    checkboxLabel: {
        marginStart: theme_1.METRICS.CONTAINER.baseMargin,
    },
    checkboxWrapper: {
        alignItems: "center",
        alignSelf: "baseline",
        flexDirection: "row",
        flexWrap: "wrap",
        padding: theme_1.METRICS.CONTAINER.basePadding,
    },
});
const getBorderedCheckboxStyle = (theme, borderColor) => theme.checkbox.borderWidth
    ? {
        borderWidth: theme.checkbox.borderWidth,
        borderColor,
        height: icons_1.IconSize.XSMALL,
        width: icons_1.IconSize.XSMALL,
    }
    : undefined;
exports.getBorderedCheckboxStyle = getBorderedCheckboxStyle;
