"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollScreen = void 0;
/* eslint-disable react/jsx-props-no-spreading */
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const util_1 = require("../../util");
const styles = react_native_1.StyleSheet.create({
    container: {
        paddingBottom: theme_1.METRICS.SCREEN.basePadding,
        paddingHorizontal: theme_1.METRICS.SCREEN.basePadding,
        paddingTop: theme_1.METRICS.CONTAINER.basePadding,
    },
    safeArea: {
        flex: 1,
    },
});
/**
 * Like Screen, applies theme background and base padding, but also makes contents scrollable.
 * You should use this or Screen as the root component of each screen in your app.
 *
 * @see Screen
 */
const ScrollScreen = ({ children, style, testID, ...otherScrollViewProps }) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const backgroundColor = (_a = react_native_1.StyleSheet.flatten([style]).backgroundColor) !== null && _a !== void 0 ? _a : theme.backgroundColor;
    return (react_1.default.createElement(react_native_1.SafeAreaView, { style: [styles.safeArea, { backgroundColor }] },
        react_1.default.createElement(react_native_1.ScrollView, { contentContainerStyle: [styles.container, style], ...otherScrollViewProps, ...(0, util_1.getTestIdProps)(testID) }, children)));
};
exports.ScrollScreen = ScrollScreen;
