import React, { FC } from "react";
import { StyleProp, ViewStyle } from "react-native";
import { TestProps } from "../../util";
import { IconProps } from "./icon-props";
export type TouchableIconProps = {
    /**
     * Icon component which will be wrapped in the touchable component.
     */
    icon: React.ComponentType<IconProps>;
    /**
     * Callback which will be called when component is pressed.
     */
    onPress: () => void;
    /**
     * If true, disables interaction with the icon. Default is false.
     */
    disabled?: boolean;
    /**
     * Additional styling rules for the component.
     */
    style?: StyleProp<ViewStyle>;
} & IconProps & TestProps;
export declare const TouchableIcon: FC<TouchableIconProps>;
//# sourceMappingURL=touchable-icon.d.ts.map