import React from "react";
import { CommonValidationProps } from "./text-field-validation-info";
import { InputFieldProps } from "./input-field";
import { TextFieldRef } from "./text-field-ref";
export type SecretInputFieldProps = Omit<InputFieldProps, "style" | "type"> & CommonValidationProps & {
    /** Label to display above the text field. */
    label: string;
    /** Current value of the text field. Required to evaluate current text length. */
    value: string;
    /** Limits the maximum number of characters that can be entered. */
    maxLength?: number;
    /** Controls whether the Show/Hide eye icon-button should be rendered. */
    eyeButtonShown?: boolean;
};
export declare const SecretInputField: React.ForwardRefExoticComponent<Omit<InputFieldProps, "style" | "type"> & CommonValidationProps & {
    /** Label to display above the text field. */
    label: string;
    /** Current value of the text field. Required to evaluate current text length. */
    value: string;
    /** Limits the maximum number of characters that can be entered. */
    maxLength?: number | undefined;
    /** Controls whether the Show/Hide eye icon-button should be rendered. */
    eyeButtonShown?: boolean | undefined;
} & React.RefAttributes<TextFieldRef>>;
//# sourceMappingURL=secret-input-field.d.ts.map