import { FC } from "react";
import { TestProps } from "../../util";
export declare enum ValidationResult {
    NONE = 0,
    OK = 1,
    WARNING = 2,
    ERROR = 3
}
export type CommonValidationProps = {
    /**
     * Type of the text field validation result.
     * Based on the type the `validationMessage` and
     * separator color is set to the according theme colors.
     */
    validationResult?: ValidationResult;
    /**
     * Text field separator color is set to disabled color or not.
     * The validation result message does not appear if it is disabled.
     *
     * Defaults to `false`.
     */
    disabled?: boolean;
    /** Text field's validation result message under the separator. */
    validationMessage?: string;
};
export type TextFieldValidationInfoProps = TestProps & CommonValidationProps & {
    focused: boolean;
};
export declare const TextFieldValidationInfo: FC<TextFieldValidationInfoProps>;
//# sourceMappingURL=text-field-validation-info.d.ts.map