import { FC } from "react";
import { ViewStyle, StyleProp } from "react-native";
import { TestProps } from "../../util";
export type ProcessIndicatorDotsProps = TestProps & {
    /** Number of dots to display. */
    maxStages: number;
    /**
     * Maximum width of the process indicator.
     * Defaults to SCREEN_WIDTH - METRICS.SCREEN.basePadding * 2.
     */
    maxWidth?: number;
    /** Highlight this dot. */
    currentStage: number;
    /** Additional styling for the container. */
    style?: StyleProp<ViewStyle>;
};
/**
 * Component used for displaying the status of a process.
 * Stages are represented as dots and the current stage
 * is highlighted.
 */
export declare const ProcessIndicatorDots: FC<ProcessIndicatorDotsProps>;
//# sourceMappingURL=process-indicator-dots.d.ts.map