"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProgressBarWrapper = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const util_1 = require("../../util");
const styles = react_native_1.StyleSheet.create({
    progressBarBackground: {
        height: 6,
        width: "100%",
    },
    progressBarWrapper: {
        paddingVertical: theme_1.METRICS.CONTAINER.basePadding,
    },
});
const ProgressBarWrapper = ({ children, testID, style: inheritedStyle, }) => {
    const { theme } = (0, theme_1.useTheme)();
    return (react_1.default.createElement(react_native_1.View, { style: [styles.progressBarWrapper, inheritedStyle], ...(0, util_1.getTestIdProps)(testID) },
        react_1.default.createElement(react_native_1.View, { style: [
                styles.progressBarBackground,
                { backgroundColor: theme.progressBar.trackColor },
            ] }, children)));
};
exports.ProgressBarWrapper = ProgressBarWrapper;
