import { FC } from "react";
import { StyleProp, ViewStyle } from "react-native";
import { TestProps } from "../../util";
export type SelectionCircleProps = TestProps & {
    /** Whether the circle should indicate a selected state. */
    selected: boolean;
    /** If `true`, renders circle with the theme's disabled colors. */
    disabled?: boolean;
    /** Whether the associated element is pressed. Defaults to `false`. */
    pressed?: boolean;
    /**
     * Additional styling to apply to the circle.
     *
     * **NOTE:** Best used only for margins / layout.
     */
    style?: StyleProp<ViewStyle>;
};
/**
 * Selection circle to be used for indicating selection in a list or for
 * radio buttons.
 */
export declare const SelectionCircle: FC<SelectionCircleProps>;
//# sourceMappingURL=selection-circle.d.ts.map