import React from "react";
import { IconProps } from "../icons";
export type SegmentedControlTabProps<T> = {
    /** Text to render inside the tab. */
    text?: string;
    /**
     * A medusa icon component to render inside the tab.
     * If text is also specified, the icon will be displayed
     * to the left of the text.
     */
    icon?: React.ComponentType<IconProps>;
    /** The value the tab represents. */
    value: T;
};
/**
 * Internal interface with properties that are overwritten by SegmentedControl.
 * They would have no effect if specified from the outside, so hide them from the public
 * interface.
 */
export type InternalTabProps<T> = SegmentedControlTabProps<T> & {
    selected: boolean;
    disabled: boolean;
    first: boolean;
    pressed: boolean;
};
/**
 * Component to be used inside SegmentedControl to list the available options.
 */
export declare function SegmentedControlTab<T>(props: SegmentedControlTabProps<T>): React.ReactElement;
//# sourceMappingURL=segmented-control-tab.d.ts.map