"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SliderWithLabel = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const text_1 = require("../text");
const slider_1 = require("./slider");
const styles = react_native_1.StyleSheet.create({
    label: {
        flex: 2,
    },
    textContainer: {
        alignItems: "center",
        flexDirection: "row",
        justifyContent: "space-between",
    },
    value: {
        flex: 1,
        textAlign: "right",
    },
});
const SliderWithLabel = ({ value, label, ...restProps }) => {
    const { theme } = (0, theme_1.useTheme)();
    const [sliding, setSliding] = (0, react_1.useState)(false);
    const [innerValue, setInnerValue] = (0, react_1.useState)(value);
    const displayedValue = sliding ? innerValue : value;
    return (react_1.default.createElement(react_native_1.View, null,
        react_1.default.createElement(react_native_1.View, { style: styles.textContainer },
            react_1.default.createElement(text_1.Label, { style: styles.label }, label),
            react_1.default.createElement(text_1.Label, { style: [
                    styles.value,
                    { color: theme.slider.default.color },
                ] }, displayedValue)),
        react_1.default.createElement(slider_1.Slider
        // eslint-disable-next-line react/jsx-props-no-spreading
        , { ...restProps, onSlidingChange: setSliding, onValueChangeVolatile: setInnerValue, value: value })));
};
exports.SliderWithLabel = SliderWithLabel;
