import React, { FC } from "react";
import { ViewStyle, StyleProp } from "react-native";
import { Colors } from "../../theme";
import { IconProps } from "../icons";
import { TestProps } from "../../util";
export type TileProps = TestProps & {
    /** Text to display below the icon or in the center if no icon is provided. */
    text: string;
    /** Color to apply as background color. Defaults to the primary color of the active theme. */
    color?: Colors;
    /** Name of a medusa-compatible icon component to show in the center of the tile. */
    icon?: React.ComponentType<IconProps>;
    /** Callback to be called when tile is pressed. */
    onPress(): void;
    /** If true, disable all interactions for this component. */
    disabled?: boolean;
    /** Additional styling to apply to the tile. */
    style?: StyleProp<ViewStyle>;
};
/**
 * A square tile to be used as a navigation element or button, mostly on dashboards.
 */
export declare const Tile: FC<TileProps>;
//# sourceMappingURL=tile.d.ts.map