"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InfoContainer = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const util_1 = require("../../util");
const icons_1 = require("../icons");
const separators_1 = require("../separators");
const styles = react_native_1.StyleSheet.create({
    container: {
        paddingHorizontal: theme_1.METRICS.SCREEN.basePadding,
        paddingVertical: theme_1.METRICS.CONTAINER.basePadding,
    },
    icon: {
        alignItems: "center",
        flex: 1,
        justifyContent: "center",
        paddingBottom: theme_1.METRICS.CONTAINER.basePadding,
        paddingTop: theme_1.METRICS.CONTAINER.basePadding,
    },
    wrapper: {
        flexDirection: "row",
    },
});
const InfoContainer = ({ style, children, testID, }) => {
    const { theme } = (0, theme_1.useTheme)();
    return children ? (react_1.default.createElement(react_native_1.View, { style: style },
        react_1.default.createElement(react_native_1.View, { style: [
                styles.wrapper,
                {
                    backgroundColor: theme.sectionBackgroundColor,
                },
            ] },
            react_1.default.createElement(react_native_1.View, { style: styles.icon },
                react_1.default.createElement(icons_1.InfoIcon, { iconSize: icons_1.IconSize.SMALL }))),
        react_1.default.createElement(separators_1.Separator, null),
        react_1.default.createElement(react_native_1.ScrollView, { style: styles.container, ...(0, util_1.getTestIdProps)(testID) }, children))) : // eslint-disable-next-line unicorn/no-null
        null;
};
exports.InfoContainer = InfoContainer;
