/// <reference types="react" />
import { TestProps } from "../../util";
export interface Item<T> {
    /** The text displayed on the list item */
    label: string;
    /** The value represented by the label. */
    value: T;
}
export type ListSelectProps<T> = TestProps & {
    /** Currently selected value from the list. A checkmark will appear on the
     * right side of the selected list item. */
    value: T;
    /** Callback that is called when an item is selected from the list. */
    onChange: (value: T) => void;
    /** Component to be displayed under the list. */
    infoComp?: JSX.Element;
    /** The list of items to be displayed in the list. The values have to be unique. */
    items: Item<T>[];
};
export declare function ListSelect<T>(props: ListSelectProps<T>): JSX.Element;
//# sourceMappingURL=list-select.d.ts.map