"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListSelect = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const list_1 = require("../list");
const info_container_1 = require("./info-container");
const select_styles_1 = require("./select-styles");
const radio_button_1 = require("../radio-button");
const theme_1 = require("../../theme");
const util_1 = require("../../util");
// The list of values can occupy at most two thirds of the component's height.
const LIST_MAX_HEIGHT = Math.floor(react_native_1.Dimensions.get("window").height * (2 / 3));
const styles = react_native_1.StyleSheet.create({
    circle: {
        marginRight: theme_1.METRICS.ICON.basePadding,
    },
    flexOneThird: {
        flex: 1,
    },
    flexTwoThird: {
        flex: 2,
    },
});
function ListSelect(props) {
    const { value, onChange, infoComp, items, testID } = props;
    // Leave as React.useState for testability
    // See: https://stackoverflow.com/a/64165871/6932518
    const [heightExceeded, setHeightExceeded] = react_1.default.useState(false);
    const onContentSizeChange = (0, react_1.useCallback)((_w, h) => {
        setHeightExceeded(h >= LIST_MAX_HEIGHT);
    }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_1.View, { style: (heightExceeded || !infoComp) && styles.flexTwoThird, ...(0, util_1.getTestIdProps)(testID) },
            react_1.default.createElement(react_native_1.ScrollView, { contentContainerStyle: select_styles_1.selectStyles.container, onContentSizeChange: onContentSizeChange, scrollEnabled: !infoComp || heightExceeded, ...(0, util_1.getTestIdProps)(`${testID}.scroll`) },
                react_1.default.createElement(list_1.List, null, items.map((item) => item.value === value ? (react_1.default.createElement(list_1.ListItem, { key: `${item.value}`, rightComponent: react_1.default.createElement(radio_button_1.SelectionCircle, { selected: true, style: styles.circle, testID: `${testID}.${item.value}.selection` }), testID: `${testID}.${item.value}`, text: item.label })) : (react_1.default.createElement(UnselectedItem, { item: item, key: `${item.value}`, onChange: onChange, testID: `${testID}.${item.value}` })))))),
        react_1.default.createElement(info_container_1.InfoContainer, { style: styles.flexOneThird, testID: `${testID}.infoContainer` }, infoComp)));
}
exports.ListSelect = ListSelect;
const UnselectedItem = ({ item, onChange, testID }) => (react_1.default.createElement(list_1.ListItem, { onPress: (0, react_1.useCallback)(() => onChange(item.value), [item.value, onChange]), rightComponent: react_1.default.createElement(radio_button_1.SelectionCircle, { selected: false, style: styles.circle, testID: `${testID}.selection` }), testID: testID, text: item.label }));
