import { FC } from "react";
import { NumberSelectProps } from "./number-select";
export type SpecialValue = {
    label: string;
    value: number;
};
export type SpecialNumberSelectProps = Omit<NumberSelectProps, "onChange"> & {
    /**
     * The values which should be handled separately from the number input.
     * They are composed of a `label` to display on the UI and a `value`.
     */
    specialValues: SpecialValue[];
    /** Label to show next to the last radio button that enables the number input. */
    customValueLabel: string;
    /** Callback that is called when the value changes. The first parameter is
     * the new value. The second parameter is a boolean that indicates whether the new value
     * came from one of the radio button options (therefore it is a special value) or
     * from the custom input.
     */
    onChange(newValue: number, isSpecialValue: boolean): void;
};
export declare const SpecialNumberSelect: FC<SpecialNumberSelectProps>;
//# sourceMappingURL=special-number-select.d.ts.map