"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChartLineCompressIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const ChartLineCompressIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M142.7 92l-7-17.5c-.6-1.6-2.2-2.6-3.9-2.5-1.7.1-3.2 1.2-3.7 2.8l-8.6 28.6-19.8-52.8c-.6-1.6-2.2-2.7-3.8-2.6-1.7 0-3.2 1.2-3.7 2.8l-24.4 76.8-12-33c-.6-1.5-2.1-2.6-3.8-2.6H40V48h-8v96h8v-44h9.2l15 41.4c.6 1.6 2.1 2.6 3.8 2.6h.1c1.7 0 3.2-1.2 3.7-2.8l24.5-77 19.9 53.2c.6 1.6 2.2 2.6 3.9 2.6 1.7-.1 3.2-1.2 3.7-2.8l8.7-29 3.7 9.4c.6 1.5 2.1 2.5 3.7 2.5h20v-8h-17.2z" }))));
};
exports.ChartLineCompressIcon = ChartLineCompressIcon;
