"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CirculationPumpIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const CirculationPumpIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M96 168a71.632 71.632 0 01-38.881-11.415l110.27-51.42c-4.538 35.414-34.751 62.794-71.39 62.835m-72-72c0-22.165 10.023-41.982 25.775-55.189l118.22 55.127v.12l-118.23 55.131C34.015 137.978 23.994 118.162 23.994 96m143.4-9.168L57.124 35.411A71.633 71.633 0 0195.998 24c36.656 0 66.893 27.399 71.399 62.832M95.998 16c-44.183 0-80 35.817-80 80s35.817 80 80 80 80-35.817 80-80c-.05-44.162-35.838-79.95-80-80", fillRule: "evenodd" }))));
};
exports.CirculationPumpIcon = CirculationPumpIcon;
