"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClubArmChairIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const ClubArmChairIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M176 94c0-7.7-6.3-14-14-14h-18V46c0-7.7-6.3-14-14-14H62c-7.7 0-14 6.3-14 14v34H30c-7.7 0-14 6.3-14 14v50h8v16h24v-16h96v16h24v-16h8V94zM56 46c0-3.3 2.7-6 6-6h68c3.3 0 6 2.7 6 6v62H56V46zM40 152h-8v-8h8v8zm8-16H24V94c0-3.3 2.7-6 6-6h18v48zm8 0v-20h80v20H56zm104 16h-8v-8h8v8zm8-16h-24V88h18c3.3 0 6 2.7 6 6v42z" }))));
};
exports.ClubArmChairIcon = ClubArmChairIcon;
