"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CookingIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const CookingIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M132 32c-6.668 0-12.973 2.318-18.01 6.566C109.12 34.472 102.845 32 96 32s-13.12 2.472-17.99 6.566C72.973 34.318 66.668 32 60 32c-15.44 0-28 12.56-28 28 0 14.082 10.449 25.768 24 27.715V128h80V87.715c13.551-1.947 24-13.633 24-27.715 0-15.44-12.56-28-28-28zm-68 88v-8h64v8H64zm68-40h-4v24H64V80h-4c-11.028 0-20-8.972-20-20s8.972-20 20-20c4.68 0 9.11 1.596 12.677 4.53A27.834 27.834 0 0068 60h8c0-11.028 8.972-20 20-20s20 8.972 20 20h8a27.834 27.834 0 00-4.677-15.47A19.844 19.844 0 01132 40c11.028 0 20 8.972 20 20s-8.972 20-20 20zm-64 64c-11.028 0-20 7.178-20 16s8.972 16 20 16c9.299 0 17.113-5.11 19.342-12H144v-8H87.342c-2.23-6.89-10.043-12-19.342-12zm0 24c-6.505 0-12-3.664-12-8s5.495-8 12-8 12 3.664 12 8-5.495 8-12 8z" }))));
};
exports.CookingIcon = CookingIcon;
