"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocumentCheckIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const DocumentCheckIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M120 100H56v-8h64v8zm-64 20h40v-8H56v8zm84 26.343l-5.171-5.172-5.658 5.658L140 157.657l18.829-18.828-5.658-5.658L140 146.343zM176 144c0 17.645-14.355 32-32 32s-32-14.355-32-32 14.355-32 32-32 32 14.355 32 32zm-8 0c0-13.234-10.766-24-24-24s-24 10.766-24 24 10.766 24 24 24 24-10.766 24-24zm-48-72H56v8h64v-8zm0 103.978V176H40V16h81.815L152 50.497v54.308a40.027 40.027 0 00-8-.805V56h-28V24H48v144h64.022a40.342 40.342 0 007.978 7.978zM124 48h15.185L124 30.646V48z" }))));
};
exports.DocumentCheckIcon = DocumentCheckIcon;
