"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InverterIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const InverterIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M157.312 108.488a24.416 24.416 0 01-17.816-9.8c-3.816-3.944-7.112-7.36-12.056-7.36-6.04 0-11.52 8.872-12.96 12l-7.264-3.376c.8-1.704 8.064-16.616 20.224-16.616a24.408 24.408 0 0117.816 9.8c3.816 3.944 7.12 7.36 12.056 7.36 7.44 0 13.08-9.352 13.128-9.448l6.928 4a26.8 26.8 0 01-20.056 13.44zM84.48 159.968L111.608 31.84h-8.416l-27.12 128.128zm-68.464-56.056v8h62.048l1.696-8zm0-24.024v8h67.128l1.696-8z" }),
            react_1.default.createElement(react_native_svg_1.Path, { fill: "none", d: "M0 0h192v192H0z" }))));
};
exports.InverterIcon = InverterIcon;
