"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoginIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const LoginIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M152.569 152.569c-15.596 15.596-36.083 23.393-56.569 23.393s-40.973-7.797-56.569-23.393l5.657-5.657c28.073 28.072 73.751 28.072 101.824 0 28.072-28.073 28.072-73.75 0-101.824-28.073-28.072-73.75-28.072-101.824 0l-5.657-5.657c31.193-31.191 81.945-31.191 113.138 0 31.191 31.193 31.191 81.945 0 113.138zM49.17 121.17l5.658 5.658L85.657 96 54.829 65.171 49.17 70.83 70.343 92H16v8h54.343l-21.172 21.171z" }))));
};
exports.LoginIcon = LoginIcon;
