"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MechanicIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const MechanicIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M91.3 104.3C104.1 98.2 113 85.1 113 70c0-21-17-38-38-38S37 49 37 70c0 15.1 8.9 28.2 21.7 34.3-24 7.1-41.7 29.4-41.7 55.7h8c0-27.6 22.4-50 50-50s50 22.4 50 50h8c0-26.3-17.7-48.6-41.7-55.7zM45 70c0-16.5 13.5-30 30-30s30 13.5 30 30-13.5 30-30 30-30-13.5-30-30z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M173.3 79.9l-2.4-5.1-20 20c-1.5 1.5-4.1 1.5-5.7 0-.8-.8-1.2-1.8-1.2-2.8s.4-2.1 1.2-2.8l20-20-5.1-2.4c-10.7-5.1-23.5-2.9-31.9 5.5-6.5 6.5-9.3 15.8-7.8 24.7l-8.4 8.4c2.2 1.5 4.4 3.2 6.4 4.9l10.9-10.9-.6-2.2c-1.8-6.9.1-14.3 5.2-19.3 4.5-4.5 10.9-6.5 17-5.7l-11.3 11.3c-2.3 2.3-3.5 5.3-3.5 8.5s1.2 6.2 3.5 8.5 5.3 3.5 8.5 3.5 6.2-1.2 8.5-3.5l11.3-11.3c.9 6.1-1.1 12.4-5.7 17-5 5-12.4 7-19.3 5.2l-2.2-.6-11.5 11.5c1.6 2.2 3 4.6 4.3 7l9.7-9.7c9 1.6 18.2-1.3 24.7-7.8 8.3-8.4 10.5-21.2 5.4-31.9z" }))));
};
exports.MechanicIcon = MechanicIcon;
