"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedirectIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const RedirectIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M173.657 100l-18.828 18.829-5.658-5.658 9.172-9.171H144c-8.822 0-16-7.178-16-16V68c0-4.411-3.589-8-8-8H68c-4.411 0-8 3.589-8 8v20c0 8.822-7.178 16-16 16H16v-8h28c4.411 0 8-3.589 8-8V68c0-8.822 7.178-16 16-16h52c8.822 0 16 7.178 16 16v20c0 4.411 3.589 8 8 8h14.343l-9.172-9.171 5.658-5.658L173.657 100zM68 104h12v-8H68v8zm20 0h12v-8H88v8zm20 0h12v-8h-12v8z" }))));
};
exports.RedirectIcon = RedirectIcon;
