"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchAlertWarningIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SearchAlertWarningIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M115.814 16L85.133 69.14a41.002 41.002 0 013.574 3.81L115.813 26l51.527 89.246H98v5h78l-2.164-3.75L115.814 16zm-4 40v16l2 18h4l2-18V56h-8zM52 68a36 36 0 00-36 36 36 36 0 0036 36 36 36 0 0018.256-5.018L111.27 176 124 163.271l-41.02-41.017A36 36 0 0088 104a36 36 0 00-36-36zm0 5a31 31 0 0131 31 31 31 0 01-31 31 31 31 0 01-31-31 31 31 0 0131-31zm0 5a26 26 0 00-26 26 26 26 0 0026 26 26 26 0 0026-26 26 26 0 00-26-26zm0 5a21 21 0 0121 21 21 21 0 01-21 21 21 21 0 01-21-21 21 21 0 0121-21zm0 5v5a11 11 0 0111 11h5a16 16 0 00-16-16zm59.814 10v8h8v-8h-8zm-31.691 28.467l36.807 36.804-5.659 5.659-36.826-36.828a36 36 0 005.678-5.635z", fillRule: "evenodd" }))));
};
exports.SearchAlertWarningIcon = SearchAlertWarningIcon;
