"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignalLostIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SignalLostIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M144 176c-17.645 0-32-14.355-32-32s14.355-32 32-32 32 14.355 32 32-14.355 32-32 32zm0-56c-13.234 0-24 10.766-24 24s10.766 24 24 24 24-10.766 24-24-10.766-24-24-24zm4.126 35.894a4.07 4.07 0 01-4.104 4.106c-2.34 0-4.149-1.81-4.149-4.106 0-2.338 1.853-4.15 4.192-4.15 2.252 0 4.061 1.855 4.061 4.15zm-7.9-18.492V128h7.546v9.402l-1.588 11.608h-4.413l-1.546-11.608zM64 112h-8v48h8v-48zm-36 20h-8v28h8v-28zm72-40h-8v68h8V92zm36 12.805V72h-8v35.35a39.647 39.647 0 018-2.545zm36 10.666V52h-8v57.381a40.235 40.235 0 018 6.09z" }))));
};
exports.SignalLostIcon = SignalLostIcon;
