"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SmarthomeIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SmarthomeIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M160 176H32V82.343l64-64 64 64V176zm-120-8h112V85.657l-56-56-56 56V168zm33.373-50.627l5.657 5.656C83.562 118.497 89.59 116 96 116s12.438 2.497 16.97 7.03l5.657-5.657C112.584 111.33 104.547 108 96 108s-16.584 3.329-22.627 9.373zM96 84c-14.958 0-29.021 5.825-39.598 16.402l5.657 5.657c18.715-18.716 49.167-18.716 67.882 0l5.657-5.657C125.021 89.825 110.958 84 96 84zm-5.657 50.343a8 8 0 1011.314 11.314 8 8 0 00-11.314-11.314z" }))));
};
exports.SmarthomeIcon = SmarthomeIcon;
