"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SmartphoneIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SmartphoneIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M132 16H60c-6.6 0-12 5.4-12 12v136c0 6.6 5.4 12 12 12h72c6.6 0 12-5.4 12-12V28c0-6.6-5.4-12-12-12zm4 148c0 2.2-1.8 4-4 4H60c-2.2 0-4-1.8-4-4V28c0-2.2 1.8-4 4-4h72c2.2 0 4 1.8 4 4v136z" }),
            react_1.default.createElement(react_native_svg_1.Circle, { cx: 96, cy: 152, r: 8 }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M104 32H88c-2.2 0-4 1.8-4 4s1.8 4 4 4h16c2.2 0 4-1.8 4-4s-1.8-4-4-4z" }))));
};
exports.SmartphoneIcon = SmartphoneIcon;
