"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpeedometerSpeedHighIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SpeedometerSpeedHighIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M176 132v4h-24v-2c0-31.31-24.943-56.89-56-57.95v-8.002c33.46 1.003 60.731 27.018 63.715 59.952h8.175C165.807 90.153 134.358 60 96 60s-69.807 30.153-71.89 68H40v8H16v-4c0-44.112 35.888-80 80-80s80 35.888 80 80zm-38.216-17.81l2.432 7.62-32.22 10.281a11.883 11.883 0 01-1.335 5.373c-2.13 4.109-6.335 6.47-10.683 6.47-1.85 0-3.724-.427-5.477-1.328a11.895 11.895 0 01-5.936-7.008 11.862 11.862 0 01.774-9.125c3.036-5.857 10.286-8.163 16.16-5.142a11.945 11.945 0 013.891 3.194l32.394-10.336zm-37.97 16.58a3.949 3.949 0 00-1.974-2.325c-1.963-1.01-4.386-.244-5.397 1.708a3.914 3.914 0 00-.256 3.013 3.949 3.949 0 001.973 2.325c1.962 1.01 4.384.244 5.398-1.708a3.915 3.915 0 00.255-3.012z" }))));
};
exports.SpeedometerSpeedHighIcon = SpeedometerSpeedHighIcon;
