"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpeedometerIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SpeedometerIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M106.327 97.15l7.488 2.814-14.07 37.443-.012-.004A3.99 3.99 0 0196 140a4 4 0 01-4-4c0-.496.102-.965.267-1.403l-.011-.004 14.071-37.444zm28.98 4.806A51.972 51.972 0 01148 136h8a59.976 59.976 0 00-14.647-39.284l-6.045 5.24zm-35.59-17.825c11.268.795 21.747 5.132 30.305 12.542l5.236-6.048c-9.876-8.552-21.97-13.557-34.977-14.475l-.564 7.98zm-8.02-7.979c-12.983.92-25.059 5.916-34.923 14.445l5.233 6.051c8.547-7.39 19.01-11.718 30.257-12.516l-.567-7.98zM36 136h8a51.973 51.973 0 0112.72-34.076l-6.041-5.245A59.975 59.975 0 0036 136zm60-80c-44.112 0-80 35.888-80 80h8c0-39.701 32.299-72 72-72s72 32.299 72 72h8c0-44.112-35.888-80-80-80z" }))));
};
exports.SpeedometerIcon = SpeedometerIcon;
