"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowSearchIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const WindowSearchIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M152 48h8v8h-8zm-16 0h8v8h-8zm36.49 107.51l-40-40a36 36 0 10-17 17l40 40a12 12 0 1017-17zM72 100a28 28 0 1128 28 28 28 0 01-28-28zm94.83 66.83a4.1 4.1 0 01-5.66 0l-38.72-38.72a36.31 36.31 0 005.66-5.66l38.72 38.72a4 4 0 010 5.66z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M123.72 152H24V72h42.08a44.36 44.36 0 018.66-8H24V40h144v24h-42.75a44.36 44.36 0 018.66 8H168v67.72l8 8V32H16v128h115.72z" }))));
};
exports.WindowSearchIcon = WindowSearchIcon;
