"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.simulatePressablePress = void 0;
const react_native_1 = require("@testing-library/react-native");
/**
 * Simulate a press in via `fireEvent` from `@testing-library/react-native`.
 * Useful to test components in their pressed state when using <Pressable>.
 */
function simulatePressablePress(element) {
    // Give enough arguments that the responder grant implementation doesn't throw type errors
    (0, react_native_1.fireEvent)(element, "onResponderGrant", {
        persist: jest.fn(),
        nativeEvent: {},
    });
}
exports.simulatePressablePress = simulatePressablePress;
