import { Colors } from "./colors";
/**
 * Changes the brightness of the provided color.
 * @param originalColor the original color which must be in hexadecimal format. Accepted formats: #ea2 or #23ae9e.
 * @param scale a number which defines how to calculate the shade of the original color
 * must be between [-1, 1]. If the scale is [0, 1] -> it will calculate the `shade` - a darker color.
 * if it's lower than 0 then returns a `tint color` - lighter color.
 *
 * @example darkenColor("#EA0016", 0.2)
 *  // returns a 20% darker red
 * @example darkenColor("#EA0016", -0.6)
 *  // returns a 60% lighter red
 */
export declare const darkenColor: (originalColor: Colors, scale: number) => string;
//# sourceMappingURL=darken-color.d.ts.map