import type { RNPrivacyComponentType } from "../native-modules";
import type { Country } from "../types";
/** Type containing methods not exported to the users of the libs. */
declare type InternalPrivacyComponent = RNPrivacyComponentType & {
    loadCountries(viewTag: number): void;
    setSelectedCountry(country: Country, viewTag: number): void;
    setSupportedCountries(countries: Country[], viewTag: number): void;
    loadActivityConsent(selectedCountry: Country, viewTag: number): void;
    loadPrivacyPolicy(selectedCountry: Country, viewTag: number): void;
    loadTermsOfUse(selectedCountry: Country, viewTag: number): void;
};
export declare const RNPrivacyComponent: InternalPrivacyComponent;
declare type RNCountrySelectorManagerType = Pick<InternalPrivacyComponent, "loadCountries">;
export declare const RNCountrySelectorManager: RNCountrySelectorManagerType;
declare type RNTTActivityComponentManagerType = Pick<InternalPrivacyComponent, "loadActivityConsent">;
export declare const RNTTActivityComponentManager: RNTTActivityComponentManagerType;
declare type RNTTPrivacyComponentManagerType = Pick<InternalPrivacyComponent, "loadPrivacyPolicy" | "loadTermsOfUse">;
export declare const RNTTPrivacyComponentManager: RNTTPrivacyComponentManagerType;
export {};
//# sourceMappingURL=internal-native-modules.d.ts.map